use node::{add::Add, constant::Constant, subtract::Subtract, Environment, Node, NodeEnum};

mod node;

#[cfg(test)]
mod tests;

fn main() {
    let mut env = Environment::new();
    
    let a = Constant::new(69.0).into();
    let b = Constant::new(420.0).into();
    let c = Constant::new(360.0).into();
    let d: NodeEnum = Subtract::new(Add::new(a,b).into(), c).into();

    println!("d_0: {}", d);
    println!("d_1: {}", d.evaluate(&mut env).unwrap());
}
